︠e39be2d6-3c47-45d7-8cd2-28ee5aa3744e︠
def rsaParameters(p,q,e):
    print 'one computes n=p*q=',p,'*',q,'=',p*q
    n=p*q
    print
    print 'one computes φ(n)=(p-1)(q-1)=',p-1,'*',q-1,'=',(p-1)*(q-1)
    print
    print 'one checks that e (=',e,') is actually coprime with φ(n) since gcd(e,φ(n))=',gcd(e,(p-1)*(q-1)) ,'and one computes its inverse d= e^(-1) mod φ(n).'
    print 'For this, one may use the extended Euclidean algorithm, or d=1/mod(e,φ(n))=',1/mod(e,(p-1)*(q-1))
    d=1/mod(e,(p-1)*(q-1))
    print
    print 'Finally, the public key is Ke=(e,n)=(',e,',',p*q,'). The private key is Kd=(d,n)=(',d,',',n,').'
    return d
︡21e6d536-f013-403a-ab1c-1ad38d2d6e17︡︡
︠f6664d1b-85ba-4b5b-bc6f-f3681b92833b︠
d=rsaParameters(47,59,17)
︡f3a65c61-d49e-40da-9b11-3311e10e47ee︡{"stdout": "one computes n=p*q= 47 * 59 = 2773\n\none computes \u03c6(n)=(p-1)(q-1)= 46 * 58 = 2668\n\none checks that e (= 17 ) is actually coprime with \u03c6(n) since gcd(e,\u03c6(n))= 1 and one computes its inverse d= e^(-1) mod \u03c6(n).\nFor this, one may use the extended Euclidean algorithm, or d=1/mod(e,\u03c6(n))= 157\n\nFinally, the public key is Ke=(e,n)=( 17 , 2773 ). The private key is Kd=(d,n)=( 157 , 2773 )."}︡
︠bc1f2ba0-3078-4d99-b303-92808c332ea3︠
def RSAencryption(m,e,n): #
    print 'Encryption: one computes',m,'^',e,'mod', n,'=',mod(m^e, n)
    encr=mod(m^e, n)
    return encr
︡54f8d3f7-ce2e-465b-a708-92f428c9891a︡︡
︠10adcdf0-5e9e-4b20-8548-00f7250b3d91︠
c=RSAencryption(66,17,2773)
︡b226f9db-e214-4597-ae88-905e174baa35︡{"stdout": "Encryption: one computes 66 ^ 17 mod 2773 = 872"}︡
︠b1c28d69-48b7-4992-a008-52f4574888f9︠
# one computes c^d mod n and one checks that it is actually equal to the original message
RSAencryption(c,157,2773)
︡f92fa101-741a-4aec-8b6b-ac0b077d3b1c︡{"stdout": "Encryption: one computes 872 ^ 157 mod 2773 = 66\n66"}︡
